diff --git a/libavformat/avformat.c b/libavformat/avformat.c
index 882927f7b1..a7bd959db5 100644
--- a/libavformat/avformat.c
+++ b/libavformat/avformat.c
@@ -30,6 +30,7 @@
 #include "libavutil/opt.h"
 #include "libavutil/pixfmt.h"
 #include "libavutil/samplefmt.h"
+#include "libavutil/tile.h"
 #include "libavcodec/avcodec.h"
 #include "libavcodec/codec.h"
 #include "libavcodec/bsf.h"
@@ -100,6 +101,10 @@ void ff_free_stream_group(AVStreamGroup **pstg)
         av_iamf_mix_presentation_free(&stg->params.iamf_mix_presentation);
         break;
     }
+    case AV_STREAM_GROUP_PARAMS_TILE_GRID: {
+        av_tile_grid_free(&stg->params.tile_grid);
+        break;
+    }
     default:
         break;
     }
diff --git a/libavformat/avformat.h b/libavformat/avformat.h
index 5d0fe82250..f259ad1367 100644
--- a/libavformat/avformat.h
+++ b/libavformat/avformat.h
@@ -1022,10 +1022,12 @@ enum AVStreamGroupParamsType {
     AV_STREAM_GROUP_PARAMS_NONE,
     AV_STREAM_GROUP_PARAMS_IAMF_AUDIO_ELEMENT,
     AV_STREAM_GROUP_PARAMS_IAMF_MIX_PRESENTATION,
+    AV_STREAM_GROUP_PARAMS_TILE_GRID,
 };
 
 struct AVIAMFAudioElement;
 struct AVIAMFMixPresentation;
+struct AVTileGrid;
 
 typedef struct AVStreamGroup {
     /**
@@ -1062,6 +1064,7 @@ typedef struct AVStreamGroup {
     union {
         struct AVIAMFAudioElement *iamf_audio_element;
         struct AVIAMFMixPresentation *iamf_mix_presentation;
+        struct AVTileGrid *tile_grid;
     } params;
 
     /**
diff --git a/libavformat/dump.c b/libavformat/dump.c
index aff51b43f6..84884121a1 100644
--- a/libavformat/dump.c
+++ b/libavformat/dump.c
@@ -22,6 +22,7 @@
 #include <stdio.h>
 #include <stdint.h>
 
+#include "libavutil/avstring.h"
 #include "libavutil/channel_layout.h"
 #include "libavutil/display.h"
 #include "libavutil/iamf.h"
@@ -35,6 +36,7 @@
 #include "libavutil/spherical.h"
 #include "libavutil/stereo3d.h"
 #include "libavutil/timecode.h"
+#include "libavutil/tile.h"
 
 #include "libavcodec/avcodec.h"
 
@@ -720,6 +722,40 @@ static void dump_stream_group(const AVFormatContext *ic, uint8_t *printed,
             }
         }
         break;
+    case AV_STREAM_GROUP_PARAMS_TILE_GRID: {
+        const AVTileGrid *tile_grid = stg->params.tile_grid;
+        AVCodecContext *avctx = avcodec_alloc_context3(NULL);
+        const char *ptr = NULL;
+        av_log(NULL, AV_LOG_INFO, " Tile Grid:");
+        dump_metadata(NULL, stg->metadata, "    ", AV_LOG_INFO);
+        if (avctx && stg->nb_streams && !avcodec_parameters_to_context(avctx, ic->streams[0]->codecpar)) {
+            avctx->width  = tile_grid->output_width;
+            avctx->height = tile_grid->output_height;
+            avctx->coded_width  = FFALIGN(tile_grid->output_width,  tile_grid->w.tile_width);
+            avctx->coded_height = FFALIGN(tile_grid->output_height, tile_grid->h.tile_height);
+            if (ic->dump_separator)
+                av_opt_set(avctx, "dump_separator", ic->dump_separator, 0);
+            buf[0] = 0;
+            avcodec_string(buf, sizeof(buf), avctx, is_output);
+            ptr = av_stristr(buf, " ");
+        }
+        avcodec_free_context(&avctx);
+        if (ptr) {
+            ptr++;
+            av_log(NULL, AV_LOG_INFO, " %s", ptr);
+            av_log(NULL, AV_LOG_VERBOSE, ",");
+        }
+        av_log(NULL, AV_LOG_VERBOSE, " %d rows, %d columns, tile size %dx%d",
+               tile_grid->tile_rows, tile_grid->tile_cols,
+               tile_grid->w.tile_width, tile_grid->h.tile_height);
+        av_log(NULL, AV_LOG_INFO, "\n");
+        for (int i = 0; i < stg->nb_streams; i++) {
+            const AVStream *st = stg->streams[i];
+            dump_stream_format(ic, st->index, i, index, is_output, AV_LOG_VERBOSE);
+            printed[st->index] = 1;
+        }
+        break;
+    }
     }
     default:
         break;
diff --git a/libavformat/options.c b/libavformat/options.c
index e79ae221d9..dd33ea3470 100644
--- a/libavformat/options.c
+++ b/libavformat/options.c
@@ -30,6 +30,7 @@
 #include "libavutil/internal.h"
 #include "libavutil/intmath.h"
 #include "libavutil/opt.h"
+#include "libavutil/tile.h"
 
 /**
  * @file
@@ -367,6 +368,9 @@ static const AVClass *stream_group_child_iterate(void **opaque)
     case AV_STREAM_GROUP_PARAMS_IAMF_MIX_PRESENTATION:
         ret = av_iamf_mix_presentation_get_class();
         break;
+    case AV_STREAM_GROUP_PARAMS_TILE_GRID:
+        ret = av_tile_grid_get_class();
+        break;
     default:
         break;
     }
@@ -427,6 +431,11 @@ AVStreamGroup *avformat_stream_group_create(AVFormatContext *s,
         if (!stg->params.iamf_mix_presentation)
             goto fail;
         break;
+    case AV_STREAM_GROUP_PARAMS_TILE_GRID:
+        stg->params.tile_grid = av_tile_grid_alloc();
+        if (!stg->params.tile_grid)
+            goto fail;
+        break;
     default:
         goto fail;
     }